//+------------------------------------------------------------------+
//|                                            iMax MTF DETECTOR.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//|                        Modified 4/5/09 Rob Cousins (to use JMA)  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, KG"

#property indicator_chart_window
#property indicator_buffers 0

extern int JMA_Long_Length=14;
extern int JMA_Short_Length=5;
extern int Corner=1;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string label7qxx = "JMA(14)_MN1";
   ObjectDelete(label7qxx);
   ObjectCreate( label7qxx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(label7qxx,"MN1",8, "Arial Bold", White);
   ObjectSet( label7qxx, OBJPROP_CORNER, Corner );
   ObjectSet( label7qxx, OBJPROP_XDISTANCE, 3 );
   ObjectSet( label7qxx, OBJPROP_YDISTANCE, 10 );   
   
   string label7xx = "JMA(14)_W1";
   ObjectDelete(label7xx);
   ObjectCreate( label7xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(label7xx,"W1",8, "Arial Bold", White);
   ObjectSet( label7xx, OBJPROP_CORNER, Corner );
   ObjectSet( label7xx, OBJPROP_XDISTANCE, 3 );
   ObjectSet( label7xx, OBJPROP_YDISTANCE, 20 );   
   
   string label8xx = "JMA(14)_D1";
   ObjectDelete(label8xx);
   ObjectCreate( label8xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(label8xx,"D1",8, "Arial Bold", White);
   ObjectSet( label8xx, OBJPROP_CORNER, Corner );
   ObjectSet( label8xx, OBJPROP_XDISTANCE, 3 );
   ObjectSet( label8xx, OBJPROP_YDISTANCE, 30 );
   
   string label1xx = "JMA(14)_H4";
   ObjectDelete(label1xx);
   ObjectCreate( label1xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(label1xx,"H4",8, "Arial Bold", White);
   ObjectSet( label1xx, OBJPROP_CORNER, Corner );
   ObjectSet( label1xx, OBJPROP_XDISTANCE, 3 );
   ObjectSet( label1xx, OBJPROP_YDISTANCE, 40 );
   
   string label2xx = "JMA(14)_H1";
   ObjectDelete(label2xx);
   ObjectCreate( label2xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(label2xx,"H1",8, "Arial Bold", White);
   ObjectSet( label2xx, OBJPROP_CORNER, Corner );
   ObjectSet( label2xx, OBJPROP_XDISTANCE, 3 );
   ObjectSet( label2xx, OBJPROP_YDISTANCE, 50 );
   
   string label3xx = "JMA(14)_M30";
   ObjectDelete(label3xx);
   ObjectCreate( label3xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(label3xx,"M30",8, "Arial Bold", White);
   ObjectSet( label3xx, OBJPROP_CORNER, Corner );
   ObjectSet( label3xx, OBJPROP_XDISTANCE, 3 );
   ObjectSet( label3xx, OBJPROP_YDISTANCE, 60 );
   
   string label4xx = "JMA(14)_M15";
   ObjectDelete(label4xx);
   ObjectCreate( label4xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(label4xx,"M15",8, "Arial Bold", White);
   ObjectSet( label4xx, OBJPROP_CORNER, Corner );
   ObjectSet( label4xx, OBJPROP_XDISTANCE, 3 );
   ObjectSet( label4xx, OBJPROP_YDISTANCE, 70 );
   
   string label5xx = "JMA(14)_M5";
   ObjectDelete(label5xx);
   ObjectCreate( label5xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(label5xx,"M5",8, "Arial Bold", White);
   ObjectSet( label5xx, OBJPROP_CORNER, Corner );
   ObjectSet( label5xx, OBJPROP_XDISTANCE, 3 );
   ObjectSet( label5xx, OBJPROP_YDISTANCE, 80 );

   string label52xx = "JMA(14)_M1";
   ObjectDelete(label52xx);
   ObjectCreate( label52xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(label52xx,"M1",8, "Arial Bold", White);
   ObjectSet( label52xx, OBJPROP_CORNER, Corner );
   ObjectSet( label52xx, OBJPROP_XDISTANCE, 3 );
   ObjectSet( label52xx, OBJPROP_YDISTANCE, 90 );

   string label6xx = "JMA(14)_TITLE";
   ObjectDelete(label6xx);
   ObjectCreate( label6xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(label6xx,"JMA(14)",8, "Arial Bold", White);
   ObjectSet( label6xx, OBJPROP_CORNER, Corner );
   ObjectSet( label6xx, OBJPROP_XDISTANCE, 36 );
   ObjectSet( label6xx, OBJPROP_YDISTANCE, 110 );

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("JMA(14)_MN1");
   ObjectDelete("JMA(14)_W1");
   ObjectDelete("JMA(14)_D1");   
   ObjectDelete("JMA(14)_H4");   
   ObjectDelete("JMA(14)_H1");
   ObjectDelete("JMA(14)_M30"); 
   ObjectDelete("JMA(14)_M15");   
   ObjectDelete("JMA(14)_M5");
   ObjectDelete("JMA(14)_M1");
   ObjectDelete("JMA(14)_TITLE");
    
   ObjectDelete("JMA(14) MN1");  
   ObjectDelete("JMA(14) W1");   
   ObjectDelete("JMA(14) D1");
   ObjectDelete("JMA(14) H4");
   ObjectDelete("JMA(14) H1");
   ObjectDelete("JMA(14) M30");
   ObjectDelete("JMA(14) M15");
   ObjectDelete("JMA(14) M5");
   ObjectDelete("JMA(14) M1");
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   
   string Sign;   
   color Col;
   
   int Time_Frame=43200; // monthly

   double Long2 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,2);
   double Long1 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,1);

   double Short2=Long2;
   double Short1=Long1;
   
   //Short2 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,2),Digits);
   //Short1 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,1),Digits);
//   double Short2 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,2),Digits);
//   double Short1 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,1),Digits);

   if (Long1>Long2 && Short1>Short2)  { Sign=""; Col=Lime; }//Trend Up
   if (Long1>Long2 && Short1<=Short2)  { Sign=""; Col=Yellow;} //Weak Trend Up
   if (Long1<Long2 && Short1<Short2)  { Sign=""; Col=Red; } //Trend Down
   if (Long1<Long2 && Short1>=Short2)  { Sign=""; Col=Yellow;}  //Weak Trend Down
   //{ Sign=""; Col=DarkOrange; } //Sideway

   string sign112xx = "JMA(14) MN1";
   ObjectDelete(sign112xx);
   ObjectCreate(sign112xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign112xx, Sign ,10, "Wingdings", Col);
   ObjectSet(sign112xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign112xx, OBJPROP_XDISTANCE, 58 );
   ObjectSet(sign112xx, OBJPROP_YDISTANCE, 10 );


//***********************************************************************************************

         
   Time_Frame=10080; // Weekly
   Long2 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,2);
   Long1 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,1);

   Short2=Long2;  // for fault finding - but it didn't work
   Short1=Long1;
   
   //Short2 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,2),Digits);
   //Short1 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,1),Digits);

   if (Long1>Long2 && Short1>Short2)  { Sign=""; Col=Lime; }//Trend Up
   if (Long1>Long2 && Short1<=Short2)  { Sign=""; Col=Yellow;} //Weak Trend Up
   if (Long1<Long2 && Short1<Short2)  { Sign=""; Col=Red; } //Trend Down
   if (Long1<Long2 && Short1>=Short2)  { Sign=""; Col=Yellow;}  //Weak Trend Down
   //{ Sign=""; Col=DarkOrange; } //Sideway


   string sign1xx = "JMA(14) W1";
   ObjectDelete(sign1xx);
   ObjectCreate(sign1xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign1xx, Sign ,10, "Wingdings", Col);
   ObjectSet(sign1xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign1xx, OBJPROP_XDISTANCE, 58 );
   ObjectSet(sign1xx, OBJPROP_YDISTANCE, 20 );
   

//***********************************************************************************************

   Time_Frame=1440; // Weekly
   Long2 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,2);
   Long1 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,1);

   Short2=Long2;
   Short1=Long1;
   
   //Short2 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,2),Digits);
   //Short1 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,1),Digits);

   if (Long1>Long2 && Short1>Short2)  { Sign=""; Col=Lime; }//Trend Up
   if (Long1>Long2 && Short1<=Short2)  { Sign=""; Col=Yellow;} //Weak Trend Up
   if (Long1<Long2 && Short1<Short2)  { Sign=""; Col=Red; } //Trend Down
   if (Long1<Long2 && Short1>=Short2)  { Sign=""; Col=Yellow;}  //Weak Trend Down
   //{ Sign=""; Col=DarkOrange; } //Sideway

   string sign2xx = "JMA(14) D1";
   ObjectDelete(sign2xx);
   ObjectCreate(sign2xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign2xx, Sign ,10, "Wingdings", Col);
   ObjectSet(sign2xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign2xx, OBJPROP_XDISTANCE, 58 );
   ObjectSet(sign2xx, OBJPROP_YDISTANCE, 30 );
   

//***********************************************************************************************

   Time_Frame=240; // Weekly
   Long2 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,2);
   Long1 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,1);

   Short2=Long2;
   Short1=Long1;
   
   //Short2 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,2),Digits);
   //Short1 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,1),Digits);

   if (Long1>Long2 && Short1>Short2)  { Sign=""; Col=Lime; }//Trend Up
   if (Long1>Long2 && Short1<=Short2)  { Sign=""; Col=Yellow;} //Weak Trend Up
   if (Long1<Long2 && Short1<Short2)  { Sign=""; Col=Red; } //Trend Down
   if (Long1<Long2 && Short1>=Short2)  { Sign=""; Col=Yellow;}  //Weak Trend Down
   //{ Sign=""; Col=DarkOrange; } //Sideway

   string sign13xx = "JMA(14) H4";
   ObjectDelete(sign13xx);
   ObjectCreate(sign13xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign13xx, Sign ,10, "Wingdings", Col);
   ObjectSet(sign13xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign13xx, OBJPROP_XDISTANCE, 58 );
   ObjectSet(sign13xx, OBJPROP_YDISTANCE, 40 );
   

//***********************************************************************************************

   Time_Frame=60; // Weekly
   Long2 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,2);
   Long1 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,1);

   Short2=Long2;
   Short1=Long1;
   
   //Short2 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,2),Digits);
   //Short1 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,1),Digits);

   if (Long1>Long2 && Short1>Short2)  { Sign=""; Col=Lime; }//Trend Up
   if (Long1>Long2 && Short1<=Short2)  { Sign=""; Col=Yellow;} //Weak Trend Up
   if (Long1<Long2 && Short1<Short2)  { Sign=""; Col=Red; } //Trend Down
   if (Long1<Long2 && Short1>=Short2)  { Sign=""; Col=Yellow;}  //Weak Trend Down
   //{ Sign=""; Col=DarkOrange; } //Sideway

   string sign23xx = "JMA(14) H1";
   ObjectDelete(sign23xx);
   ObjectCreate(sign23xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign23xx, Sign ,10, "Wingdings", Col);
   ObjectSet(sign23xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign23xx, OBJPROP_XDISTANCE, 58 );
   ObjectSet(sign23xx, OBJPROP_YDISTANCE, 50 );


//***********************************************************************************************

   Time_Frame=30; // Weekly
   Long2 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,2);
   Long1 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,1);

   Short2=Long2;
   Short1=Long1;
   
   //Short2 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,2),Digits);
   //Short1 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,1),Digits);

   if (Long1>Long2 && Short1>Short2)  { Sign=""; Col=Lime; }//Trend Up
   if (Long1>Long2 && Short1<=Short2)  { Sign=""; Col=Yellow;} //Weak Trend Up
   if (Long1<Long2 && Short1<Short2)  { Sign=""; Col=Red; } //Trend Down
   if (Long1<Long2 && Short1>=Short2)  { Sign=""; Col=Yellow;}  //Weak Trend Down
   //{ Sign=""; Col=DarkOrange; } //Sideway

   string sign33xx = "JMA(14) M30";
   ObjectDelete(sign33xx);
   ObjectCreate(sign33xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign33xx, Sign ,10, "Wingdings", Col);
   ObjectSet(sign33xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign33xx, OBJPROP_XDISTANCE, 58 );
   ObjectSet(sign33xx, OBJPROP_YDISTANCE, 60 );


//***********************************************************************************************

   Time_Frame=15; // Weekly
   Long2 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,2);
   Long1 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,1);

   Short2=Long2;
   Short1=Long1;
   
   //Short2 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,2),Digits);
   //Short1 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,1),Digits);

   if (Long1>Long2 && Short1>Short2)  { Sign=""; Col=Lime; }//Trend Up
   if (Long1>Long2 && Short1<=Short2)  { Sign=""; Col=Yellow;} //Weak Trend Up
   if (Long1<Long2 && Short1<Short2)  { Sign=""; Col=Red; } //Trend Down
   if (Long1<Long2 && Short1>=Short2)  { Sign=""; Col=Yellow;}  //Weak Trend Down
   //{ Sign=""; Col=DarkOrange; } //Sideway

   string sign35xx = "JMA(14) M15";
   ObjectDelete(sign35xx);
   ObjectCreate(sign35xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign35xx, Sign ,10, "Wingdings", Col);
   ObjectSet(sign35xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign35xx, OBJPROP_XDISTANCE, 58 );
   ObjectSet(sign35xx, OBJPROP_YDISTANCE, 70 );
   

//***********************************************************************************************

   Time_Frame=5; // Weekly
   Long2 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,2);
   Long1 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,1);

   Short2=Long2;
   Short1=Long1;
   
   //Short2 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,2),Digits);
   //Short1 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,1),Digits);

   if (Long1>Long2 && Short1>Short2)  { Sign=""; Col=Lime; }//Trend Up
   if (Long1>Long2 && Short1<=Short2)  { Sign=""; Col=Yellow;} //Weak Trend Up
   if (Long1<Long2 && Short1<Short2)  { Sign=""; Col=Red; } //Trend Down
   if (Long1<Long2 && Short1>=Short2)  { Sign=""; Col=Yellow;}  //Weak Trend Down
   //{ Sign=""; Col=DarkOrange; } //Sideway

   string sign34xx = "JMA(14) M5";
   ObjectDelete(sign34xx);
   ObjectCreate(sign34xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign34xx, Sign ,10, "Wingdings", Col);
   ObjectSet(sign34xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign34xx, OBJPROP_XDISTANCE, 58 );
   ObjectSet(sign34xx, OBJPROP_YDISTANCE, 80 );
   

//***********************************************************************************************

   Time_Frame=1; // Weekly
   Long2 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,2);
   Long1 = iCustom(NULL,Time_Frame,"JMA",JMA_Long_Length,0,0,1);

   Short2=Long2;
   Short1=Long1;
   
   //Short2 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,2),Digits);
   //Short1 = NormalizeDouble(iCustom(NULL,Time_Frame,"JMA",JMA_Short_Length,0,0,1),Digits);

   if (Long1>Long2 && Short1>Short2)  { Sign=""; Col=Lime; }//Trend Up
   if (Long1>Long2 && Short1<=Short2)  { Sign=""; Col=Yellow;} //Weak Trend Up
   if (Long1<Long2 && Short1<Short2)  { Sign=""; Col=Red; } //Trend Down
   if (Long1<Long2 && Short1>=Short2)  { Sign=""; Col=Yellow;}  //Weak Trend Down
   //{ Sign=""; Col=DarkOrange; } //Sideway

   string sign343xx = "JMA(14) M1";
   ObjectDelete(sign343xx);
   ObjectCreate(sign343xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign343xx, Sign ,10, "Wingdings", Col);
   ObjectSet(sign343xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign343xx, OBJPROP_XDISTANCE, 58 );
   ObjectSet(sign343xx, OBJPROP_YDISTANCE, 90 );


//----
   return(0);
  }
//+------------------------------------------------------------------+